/***************************************************************************
                          ipsorcery.c  -  main for console
                             -------------------
    begin                : Sun Sep 23 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : phric@legions.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "wand.h"



void usage(char *progname)
{

  printf("\nUsage: %s [options]\n"
         "IP: [-is|-id|-ih|-iv|-il|-it|-io|-id|-ip]\n"
         "-is: source host or address def. 127.0.0.1\n"
         "-id: source destination or adress def. 127.0.0.1\n"
         "-ih: IP header length def. 5\n"
         "-iv: IP version def. 4\n"
         "-il: Time-to-Live def. 64\n"
         "-it: Type-of-Service def. 0\n"
         "-io: IP frag offset [(D)on't Fragment|(M)ore Fragments|(F)ragment|(N)one]\n"
         "-ii: IP packet ID for fragmentaion def. 0\n"
         "-ip: IP protocol [TCP|UDP|ICMP|IP] def. TCP\n"
         "-iO: IP options\n"
         "TCP: [-ts|-td|-to|-tq|-ta|-tf|-tw|-tu]\n"
         "-ts: TCP source port, def. rand()\n"
         "-td: TCP destination port def. 80\n"
         "-to: TCP data offset of header def. 5\n"
         "-tq: TCP sequence number def. rand()\n"
         "-ta: TCP ack sequence number def. 0\n"
         "-tf: TCP flags [(S)yn|(A)ck|(F)in|(P)ush|(R)st|(U)rg|(N)one] def. S\n"
         "-tw: TCP Window Size def. rand()\n"
         "-tu: TCP urg pointer def. 0\n"
         "UDP: [-us|-ud|-ul]\n"
         "-us: UDP source port def. rand()\n"
         "-ud: UDP destination port def. 161\n"
         "-ul: UDP length\n"
            "RIP: [-uR|-uRc|-uRv]\n"
            "-uR: Send default RIP packet to port 520\n"
            "-uRc: RIP command [RQ|RS|TN|TF|SR|TQ|TS|TA|UQ|US|UA] def. RQ\n"
            "-uRv: RIP version [1|2] def. 2\n"
            "-uRa: RIP Entry Address \n"
            "-uRn: RIP Entry Netmask \n"
            "-uRh: RIP Entry Next Hop\n"
            "-uRm: RIP Entry Metric\n" 
            "-uRr: RIP Entry Route Tag\n"
            "-uRe: Add RIP default entry table to packet\n"
         "ICMP: [-ct|-cs]\n"
         "-ct: ICMP type def. ECHO REQUEST\n"
         "-cs: ICMP sub code def. 0\n"
         "-ci: ICMP sequence ID def. 0\n"
         "For list of ICMP Types and Subcodes run program with -h icmp.\n"
         "IGMP:[-gt|-gc|-ga|-gn]\n"
         "-gt: IGMP type [D|L|M|MT|MR|P|R1|R2|R3] def. M\n"
         "-gc: IGMP sub code for types P and D def. 0\n"
         "-gm: IGMP Max. resp. Time for Queries ie. MR\n"
         "-ga: IGMP group address def. 0\n"
         "-gn: IGMP no router alert or no internetwork Type-Of-Service [r|i||]\n"
         "For list of IGMP Types and Subcodes run program with -h igmp.\n"
         "-D \"<data>\": for datapayload\n"
         "-N <num packets>: send <num packets> number packets \n"
         ,progname
        );

  exit(-1);
}

void icmp_info(void)
{
  printf("ICMP Types and Subcodes:\n"
         "Types:\n"
         "Echo Reply                   0\n"
         "Destination Unreachable      3\n"
         "  Subcodes:\n"
         "     Network Unreachable   0\n"
         "     Host Unreachable      1\n"
         "     Protocol Unreachable  2\n"
         "     Port Unreachable      3\n"
         "     Fragmentation Needed  4\n"
         "     Source Route Failed   5\n"
         "     Network Unknown       6\n"
         "     Host Unknown          7\n"
         "     Host Isolated         8\n"
         "     Network Prohibited    9\n"
         "     Host Prohibited      10\n"
         "     Bad TOS for Network  11\n"
         "     Bad TOS for Host     12\n"
         "     Packet Filtered      13\n"
         "     Precedence Violation 14\n"
         "     Precedence Cutoff    15\n\n"
         "Source Quench                4\n"
         "Redirect                     5\n"
         "  Subcodes:\n"
         "     Redirect Network      0\n"
         "     Redirect Host         1\n"
         "     Redirect Network TOS  2\n"
         "     Redirect Host TOS     3\n\n"
         "Echo Request                 8\n"
         "Router Advertisement         9\n"
         "Router Solicitation         10\n"
         "Time Exceeded               11\n"
         "  Subcodes:\n"
         "     Time to Live          0\n"
         "     Frag Reassembly       1\n\n"
         "Parameter Problems          12\n"
         "  Subcode:\n"
         "     Option Missing        0\n\n"
         "Timestamp Request           13\n"
         "Timestamp Reply             14\n"
         "Information Request         15\n"
         "Information Reply           16\n"
         "Address Mask Request        17\n"
         "Address Mask Reply          18\n"
         "Traceroute                  30\n"
         "  Subcodes:\n"
         "     Successful Forward    0\n"
         "     No Route              1\n\n"
         "Conversion Error            31\n"
         "Mobile Host Redirect        32\n"
         "IPv6 Where Are You?         33\n"
         "IPv6 I am Here              34\n"
         "Mobile Reg. Request         35\n"
         "Mobile Reg. Reply           36\n"
         "Domain Name Request         37\n"
         "Domain Name Reply           38\n"

        );
  exit(0);

}

void igmp_info()
{

  printf("IGMP Types: [D|L|M|MR|MT|P|R1|R2|R3]\n"
         "  DVMRP:                        D\n"
         "    Subcode:\n"
         "          Probe:            1\n"
         "          Report:           2\n"
         "          Ask Neighbors:    3\n"
         "          Neighbors:        4\n"
         "          Ask Neighbors 2:  5\n"
         "          Neighbors V. 1:   6\n"
         "          Prune:            7\n"
         "          Graft:            8\n"
         "          Graft ACK:        9\n"
         "  Membership Query:             M\n"
         "    Subcode = Max Response Time\n"
         "  Membership Report Version 1:  R1\n"
         "  Membership Report Version 2:  R2\n"
         "  Membership Report Version 3:  R3\n"
         "  Member Trace:                 MT\n"
         "  Member Response:              MR\n"
         "    Subcode = Max Response Time\n"
         "  Leave Group:                  L\n"
         "  PIM Version 1:                P\n"
         "    Subcode:\n"
         "          Register:         1\n"
         "          Register Stop:    2\n"
         "          Join/Prune:       3\n"
         "          RP Reachable:     4\n"
         "          Assert:           5\n"
         "          Graft:            6\n"
         "          Graft ACK:        7\n"
         "          Mode:             8\n"
        );
  exit(0);

}


int main(int argc, char **argv)
{
  static int num_spells = 1;
  static int x = 1, tcp_go = 0, udp_go = 0, icmp_go = 0, igmp_go = 0;
  static int d_size = 0, rip_go = 0;
  struct protoent *ourproto;
  struct ip *eyep = clalloc(S_IP);
  struct tcphdr *tcpea = NULL;
  struct udphdr *udpea = NULL;
  struct icmp *icmpea = NULL;
  struct igmp *igmpea = NULL;
  struct rip *ripe = NULL;
  static char *temp = NULL;
  static char *data = NULL;
  static int ip_optlen = 0;
  static int ip_opt = 0;
  static int ip_opte = 0;

  if(argc <= 1){ usage(argv[0]); }  /* if no arguments print usage */

  srand(time(NULL)); /* seed current time for random numbers*/

  /* Everyone of our packets use IP! */
  ip_sorcery(eyep,
             wherefromto("127.0.0.1"),
             wherefromto("127.0.0.1"),
             6,
             5,
             4,
             0,
             40,
             0,
             64,
             0
            );

/* if we got one argument lets parse it*/
if(argc > 1)
{

for(;x < argc; x++)
{

  if(argv[x][0] != '-')
  {
    fprintf(stderr, "Bad Option: %s, see usage -h\n",argv[x]);
  }

  switch((int)argv[x][1])
  {


    case 'i':

    if(argv[x][2] && !argv[x][3])
    {
    if(argv[x + 1])
    {

    switch((int)argv[x][2])
     {

       case 's':
       eyep->ip_src = wherefromto(argv[x + 1]);
       break;

       case 'd':
       eyep->ip_dst = wherefromto(argv[x + 1]);
       break;

       case 'h':
       eyep->ip_hl = atoi(argv[x + 1]);
       break;

       case 'v':
       eyep->ip_v = atoi(argv[x + 1]);
       break;

       case 'l':
       eyep->ip_ttl = atoi(argv[x + 1]);
       break;

       case 't':
       eyep->ip_tos = atoi(argv[x + 1]);
       break;


       case 'o':
       if(strstr(argv[x + 1], "F"))
       {  eyep->ip_off = htons(0x1000); }
       else if(strstr(argv[x + 1], "D"))
       { eyep->ip_off = htons(0x4000); }
       else if(strstr(argv[x + 1], "M"))
       { eyep->ip_off = htons(0x2000); }
       else if(strstr(argv[x + 1], "N"))
       { eyep->ip_off = 0; }
       break;

       case 'i':
       eyep->ip_id = atoi(argv[x + 1]);
       break;

       case 'p':
         if((ourproto = getprotobyname(argv[x + 1])) == NULL)
         {
           perror("Getprotobyname:");
           exit(-1);
         }
         eyep->ip_p = ourproto->p_proto;
       break;

      case 'O':

      if(strstr(argv[x + 1], "N"))
      { ip_opt = OPT_NOOP; ip_optlen = 0; }

      if(strstr(argv[x + 1], "R") && !strstr(argv[x + 1], "TR"))
      { ip_opt = OPT_ROUTERA; ip_optlen = 4; }

      /* this needs more data for option */
      if(strstr(argv[x + 1], "TR"))
      { ip_opt = OPT_TRACERO; ip_optlen = 12; }
      break;


       default:
         fprintf(stderr, "Bad Option: %s, see usage -h\n", argv[x]);
         exit(-1);
       break;

      }
    }
    else { printf("Bad input: %s, for %s\n", argv[x + 1], argv[x]); exit(-1); }

    }
    else { printf("Bad option: %s\n", argv[x]); exit(-1); }

    x++; /* increment x so we skip the next argument */
    break; /* end of IP header arguments */

    case 't':
    if(icmp_go || udp_go || igmp_go)
    { fprintf(stderr, "Only one protocol at a time please!\n"); exit(-1); }

    if(argv[x][2] && !argv[x][3])
    {
    if(argv[x + 1])
    {
    /* intialize tcp packet */
    if(!tcp_go)
    {
      d_size = 65535 - (S_IP + sizeof(struct tcphdr));
      tcpea = clalloc(sizeof(struct tcphdr));
      tcpea->th_sport = htons(rand() % 3000);  /* random source port <= 3000 */
      tcpea->th_dport = htons(23);
      tcpea->th_off = htons(5);
      tcpea->th_seq = htonl(rand() % 9000000000); /* sequence number */
      tcpea->th_ack = 0;    /* ack sequence */
      tcpea->th_flags = TH_SYN; /* default tcp SYN packet */
      tcpea->th_win = htons((rand() % 1024) + 300); /* 300 <= random window size <= 1324 */
      tcpea->th_urp = 0;
      tcp_go++; /* so we don't intialize again */
    }


      switch((int)argv[x][2])
      {
        case 's':
        tcpea->th_sport = htons(atoi(argv[x+1]));
        break;

        case 'd':
        tcpea->th_dport = htons(atoi(argv[x+1]));
        break;

        case 'o':
        tcpea->th_off = htons(atoi(argv[x+1]));
        break;

        case 'q':
        tcpea->th_seq = htonl(atoi(argv[x+1]));
        break;

        case 'a':
        tcpea->th_ack = htonl(atoi(argv[x+1]));
        break;

        case 'f':
        tcpea->th_flags = 0;
        if(strchr(argv[x+1], 'S'))
        { tcpea->th_flags += TH_SYN; }
        if(strchr(argv[x+1], 'A'))
        { tcpea->th_flags += TH_ACK; }
        if(strchr(argv[x+1], 'F'))
        { tcpea->th_flags += TH_FIN; }
        if(strchr(argv[x+1], 'R'))
        { tcpea->th_flags += TH_RST; }
        if(strchr(argv[x+1], 'U'))
        { tcpea->th_flags += TH_URG; }
        if(strchr(argv[x+1], 'P'))
        { tcpea->th_flags += TH_PUSH; }
        if(strchr(argv[x+1], 'N'))
        { tcpea->th_flags = 0; }
        break;

        case 'w':
        tcpea->th_win = htons(atoi(argv[x+1]));
        break;

        case 'u':
        tcpea->th_urp = atoi(argv[x+1]);
        break;

        default:
          fprintf(stderr, "Bad Option: %s, see usage -h\n", argv[x]);
          exit(-1);
        break;
      }
    }
    else { printf("Bad input: %s, for %s\n", argv[x + 1], argv[x]); exit(-1); }
    }
    else { printf("Bad option: %s\n", argv[x]); exit(-1); }


    x++;
    break; /* end of TCP header arguments */

    case 'u':
    if(tcp_go || icmp_go || igmp_go)
    { fprintf(stderr, "Only one protocol at a time please!\n"); exit(-1); }

    if(argv[x][2])
    {

    /* intialize packet at max data size */
    if(!udp_go)
    {
      d_size = 65535 - S_IP + sizeof(struct udphdr);  /* max data size */
      udpea = clalloc(sizeof(struct udphdr));
      udpea->uh_sport = htons(rand() % 3000);  /* source port */
      udpea->uh_dport = htons(20);   /* destination port */
      udpea->uh_ulen = sizeof(struct udphdr);
      udp_go++;     /* so we don't intialize again */
    }

      switch((int)argv[x][2])
      {
        case 's':
        udpea->uh_sport = htons(atoi(argv[x + 1]));
        break;

        case 'd':
        udpea->uh_dport = htons(atoi(argv[x + 1]));
        break;

          
        /* woohoo we have RIP added!! */
        case 'R':
        if(!rip_go) 
        {
          /* RIP broadcast */
          eyep->ip_dst = wherefromto("224.0.0.9");
          udpea->uh_dport = htons(520);
          ripe = clalloc(sizeof(struct rip));
          ripe->comm = 0x01;
          ripe->vers = 0x02; /* vers 2 */
          ripe->none = 0;
          rip_go++;
        }

        switch((int)argv[x][3])
        {
          /* RIP commands */ 
          case 'c':
           if(argv[x + 1])
           {
             if(strstr(argv[x + 1], "RQ")) 
             { ripe->comm = 0x01; }
             else if(strstr(argv[x + 1], "RS"))
             { ripe->comm = 0x02; }
             else if(strstr(argv[x + 1], "TN"))
             { ripe->comm = 0x03; }
             else if(strstr(argv[x + 1], "TF"))
             { ripe->comm = 0x04; }  
             else if(strstr(argv[x + 1], "SR"))
             { ripe->comm = 0x05; }
             else if(strstr(argv[x + 1], "TQ"))
             { ripe->comm = 0x06; }
             else if(strstr(argv[x + 1], "TS"))
             { ripe->comm = 0x07; }
             else if(strstr(argv[x + 1], "TA"))
             { ripe->comm = 0x08; } 
             else if(strstr(argv[x + 1], "UQ"))
             { ripe->comm = 0x09; }
             else if(strstr(argv[x + 1], "US"))
             { ripe->comm = 0x0a; }
             else if(strstr(argv[x + 1], "UA"))
             { ripe->comm = 0x0b; }
           }  
          break;

          case 'v':
           if(argv[x + 1])
           {
             switch((int)argv[x + 1])
             {
               case 1:
                ripe->vers = 0x01;  
               break;
         
               case 2:
                ripe->vers = 0x02;
               break;

               default:
                fprintf(stderr,"Bad option so we will choose RIP version 2\n");
                ripe->vers = 0x02;
               break;               
             }
           }
          break;
         
          /* 
             this is all for RIP Entries we specify the address
             family for them but only if they choose a, n or h
          */
          case 'a':
          ripe->addr_fam = PF_INET;
          if(argv[x + 1])
          {
            ripe->addr = wherefromto(argv[x + 1]);
          }
          else
          {
            fprintf(stderr, "No RIP Entry address specified using 127.0.0.1\n");
            ripe->addr = wherefromto("127.0.0.1");
          }
          break;
          
          case 'n':
          ripe->addr_fam = PF_INET;
          if(argv[x + 1])
          {
            ripe->mask = wherefromto(argv[x + 1]);
          }
          else
          {
            fprintf(stderr, "No RIP Entry netmask specified using 127.0.0.1\n");
            ripe->mask = wherefromto("127.0.0.1");
          }
          break;

          case 'h':
          ripe->addr_fam = PF_INET;
          if(argv[x + 1])
          {
            ripe->nhop = wherefromto(argv[x + 1]);
          }
          else
          {
            fprintf(stderr, "No RIP Entry address specified using 127.0.0.1\n");
            ripe->nhop = wherefromto("127.0.0.1");
          }
          break;
 
          case 'm':
          if(argv[x + 1])
          {
            ripe->metric = atoi(argv[x + 1]);
          }
          break;
 
          case 'r':
          if(argv[x + 1])
          {
            ripe->route_tag = atoi(argv[x + 1]);
          }
          break;

          case 'e':
          ripe->addr_fam = PF_INET;
          ripe->nhop = wherefromto("192.168.0.1");
          ripe->metric = 0x10;
          ripe->route_tag = 0;
          ripe->addr = wherefromto("127.0.0.1");
          ripe->mask = wherefromto("255.255.255.0"); 
          break;

        } /* end RIP switch */
        break; /* End RIP  case 'R'*/
        
 
        case 'l':
        udpea->uh_ulen = atoi(argv[x + 1]);
        break;

        /* for SDBM some weird military protocol */
        case 'm':
        ip_opt = htons(0x9510);
        ip_optlen = 6;
        ip_opte = htonl(0x7f000001);
       /*
        if(argv[x + 1])
        {
          sdbm[0] = strtok(argv[x + 1],",");
          printf("sdbm:%s\n",sdbm[0]);
          memcpy(ipopte, (char *)inet_addr(sdbm[0]), 4);
          for(i = 1; (sdbm[i] = strtok(argv[x + 1], NULL)) != NULL; i++)
          { memcpy(ipopte, (char *)inet_addr(sdbm[i]), 4 + (i * 4)); }
        }
       */
        break;

        default:
          fprintf(stderr, "Bad Option: %s, see usage -h\n", argv[x]);
          exit(-1);
        break;
       }

    }
    else { printf("Bad option: %s\n", argv[x]); exit(-1); }

    x++;
    break; /* end of UDP header arguments */

    /* start ICMP arguments */
    case 'c':

      if(tcp_go || udp_go || igmp_go)
      { fprintf(stderr, "Only one protocol at a time please!\n"); exit(-1); }

      if(argv[x][2] && !argv[x][3])
      {
      if(argv[x + 1])
      {

      /* intialize our ICMP header */
      if(!icmp_go)
      {
        d_size = 65535 - (S_IP + S_ICMP);
        icmpea = clalloc(S_ICMP);
        icmpea->icmp_type = ICMP_ECHO;
        icmpea->icmp_code = 0;
        icmp_go++;
      }
      switch((int)argv[x][2])
      {
        /* should we error check our type and subcodes?
           this prevents experimenting or codes and types I missed..
        */
        case 't':
        icmpea->icmp_type = atoi(argv[x + 1]);
          switch((int)icmpea->icmp_type)
          {
             case 30:

             ip_opt = htonl(0x520c0000);
             ip_optlen = 12;
             break;
          }
        break;

        case 's':
        icmpea->icmp_code = atoi(argv[x + 1]);
        break;


        case 'i':
        icmpea->icmp_ex.seqid.id = atoi(argv[x + 1]);
        break;

        default:
         fprintf(stderr, "Bad Option: %s, see usage -h\n", argv[x]);
         exit(-1);
        break;
      }
    }
    else { printf("Bad input: %s, for %s\n", argv[x + 1], argv[x]); exit(-1); }
    }
    else { printf("Bad option: %s\n", argv[x]); exit(-1); }

    x++;
    break; /* end of ICMP header arguments */

    /* start IGMP */
    case 'g':

      if(tcp_go || udp_go || icmp_go)
      { fprintf(stderr, "Only one protocol at a time please!\n"); exit(-1); }

      if(argv[x][2] && !argv[x][3])
      {

      /* intialize our IGMP header */
      if(!igmp_go)
      {
        d_size = 65535 - (S_IP + S_IGMP);
        igmpea = clalloc(S_IGMP);
        eyep->ip_tos = 0xc0; /* internetwork traffic */
        ip_opt = htonl(0x94040000); /* router alert */
        ip_optlen = 4; /* IP option length */

        /* inet_ntoa("224.0.0.1", &igmpea->group); */
        eyep->ip_ttl = 1; /* IGMP ttl needs to always be one */
        igmp_go++;
      }
      switch((int)argv[x][2])
      {
        case 't':

        if(argv[x + 1])
        {
          if(strstr(argv[x + 1], "MR"))
          { igmpea->type = IGMP_MRESP; }
          if(strstr(argv[x + 1], "MT"))
          { igmpea->type = IGMP_MTRACE; }
          else if(strstr(argv[x + 1], "M"))
          { igmpea->type = IGMP_MEM_QUERY; }
          else if(strstr(argv[x + 1], "R1"))
          {
            igmpea->type = IGMP_V1_MEM_REP;
          }
          else if(strstr(argv[x + 1], "R2"))
          { igmpea->type = IGMP_V2_MEM_REP; }
          else if(strstr(argv[x + 1], "R3"))
          { igmpea->type = IGMP_V3_MEM_REP; }
          else if(strstr(argv[x + 1], "L"))
          { igmpea->type = IGMP_V2_LEAVE_GROUP; }
          else if(strstr(argv[x + 1], "P"))
          { igmpea->type = IGMP_V1_PIM; }
          else if(strstr(argv[x + 1], "D"))
          { igmpea->type = IGMP_DVMRP; }
          else{ igmpea->type = atoi(argv[x + 1]); }
        }

        break;

        case 'n':
        if(argv[x + 1])
        {
          if(strstr("i", argv[x + 1])){ eyep->ip_tos = 0; }
          if(strstr("r", argv[x + 1])){ ip_opt = 0; ip_optlen = 0; }
        }
        else { eyep->ip_tos = 0; ip_opt = 0; ip_optlen = 0; }

        break;

        case 'm': /* max resp. time */
        if(argv[x + 1]){ igmpea->multi.mrt = atoi(argv[x + 1]); }
        break;

        case 'c': /* sub code */
        if(argv[x + 1]){ igmpea->multi.code = atoi(argv[x + 1]); }
        break;

        case 'a': /* group address */
        if(argv[x +1])
        {
          if(inet_aton(argv[x + 1], &igmpea->group) == 0)
          {
            fprintf(stderr,"IGMP group address invalid!");
            exit(-1);
          }
        }
        break;

        default:
          fprintf(stderr, "Bad Option: %s, see usage -h\n", argv[x]);
          exit(-1);
        break;
      }

    }
    else { printf("Bad option: %s\n", argv[x]); exit(-1); }

    x++;
    break; /* end of IGMP header arguments */

    /* get data and make sure it is small enough for one packet */
    case 'D':
    if(argv[x + 1])
    {
      /* make sure they don't try to stuff in too much data */
      if(strlen(argv[x + 1]) > d_size)
      { fprintf(stderr,"Data size too big!\n"); exit(-1); }

      data = clalloc(d_size); /* allocate data */
      memcpy(data, argv[x + 1], strlen(argv[x + 1]));
      d_size = strlen(argv[x + 1]);
    }
    x++;
    break;

    case 'N':

      if(argv[x + 1])
      {
        num_spells = atoi(argv[x + 1]);
      }
    x++;
    break;

    case 'h':
    if(!argv[x + 1]){ usage(argv[0]); }
    else if(strstr(argv[x + 1], "icmp")){ icmp_info(); }
    else if(strstr(argv[x + 1], "igmp")){ igmp_info(); }
    break;

    default:
      fprintf(stderr, "Bad Option: %s, see usage -h\n", argv[x]);
      exit(-1);
    break;

  }/* switch argv[x][1] */

} /* for(... */

}/* if(argc > 1) */

if(!data){ d_size = 0; }
/* hit up our main functions */
  if(tcp_go)
  {
    tcp_sorcery(tcpea, eyep, data, d_size, ip_opt, ip_optlen, num_spells);
    free(tcpea);
  }

  else if(udp_go)
  {
    if(rip_go)
    { 
      if(data)
      { temp = data; }
      else
      { data = clalloc(512); }
      memcpy(data, ripe, sizeof(struct rip)); 
      if(temp)
      { memcpy(data + sizeof(struct rip), temp, d_size); }
      d_size = d_size + sizeof(struct rip);
      free(ripe);
    }
    eyep->ip_p = 17;
    udp_sorcery(udpea, eyep, data, d_size, ip_opt, ip_optlen, ip_opte, num_spells);
    free(udpea);
  }

  else if(icmp_go)
  {
    eyep->ip_p = 1;
    icmp_sorcery(icmpea, eyep, data, d_size, ip_opt, ip_optlen, num_spells);

    free(icmpea);
  }

  else if(igmp_go)
  {
    eyep->ip_p = 2;
    igmp_sorcery(igmpea, eyep, data, d_size, ip_opt, ip_optlen, num_spells);

    free(igmpea);
  }

  /* free our memory */
  if(data){ free(data); }
  free(eyep);

  return 0;
}


