/***************************************************************************
                          tcp.c  -  for tcp
                             -------------------
    begin                : Mon Oct 22 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : phric@legions.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "wand.h"

 /* globabls for tcp header(all text boxes) */
GtkWidget *src_te, *dst_te, *d_off_te, *seq_te, *ackseq_te;
GtkWidget *window_te, *urgp_te, *payload;

/* all labels and check boxes */
GtkWidget *src_lbl, *dst_lbl, *d_off_lbl, *seq_lbl, *ackseq_lbl;
GtkWidget *flag_lbl, *window_lbl, *urgp_lbl;
GtkWidget *syn_check, *ack_check, *psh_check, *rst_check, *fin_check, *urg_check;


void tcp_spell(void)
{
  src_lbl = make_label(src_lbl, "Source Port:", 40, 290);
  src_te = make_text(src_te, 50, 22, 120, 290);

  dst_lbl = make_label(dst_lbl, "Destination Port:", 190, 290);
  dst_te = make_text(dst_te, 50, 22, 290, 290);

  d_off_lbl = make_label(d_off_lbl, "Data Offset:", 360, 290);
  d_off_te = make_text(d_off_te, 30, 22, 440, 290);

  ackseq_lbl = make_label(ackseq_lbl, "ACK Sequence Number:", 290, 370);
  ackseq_te = make_text(ackseq_te, 80, 22, 440, 370);

  seq_lbl = make_label(seq_lbl, "Sequence Number:", 40, 370);
  seq_te = make_text(seq_te, 80, 22, 160, 370);

  syn_check = make_check(syn_check, "SYN", 120, 330);
  ack_check = make_check(ack_check, "ACK", 180, 330);
  psh_check = make_check(psh_check, "PSH", 240, 330);
  rst_check = make_check(rst_check, "RST", 300, 330);
  fin_check = make_check(fin_check, "FIN", 360, 330);
  urg_check = make_check(urg_check, "URG", 420, 330);

  window_lbl = make_label(window_lbl, "Window Size:", 40, 410);
  window_te = make_text(window_te, 80, 22, 140, 410);

  urgp_lbl = make_label(urgp_lbl, "Urgent Pointer:", 340, 410);
  urgp_te = make_text(urgp_te, 80, 22, 440, 410);
  payload = make_te(payload, 520, 80, 40, 460);

  tcp_defaults();
}

void tcp_defaults(void)
{

  char rando[10];
  char windo[6];
  char srco[6];

  /* so we can have a random sequence, source port , and window */
  srand(time(0));
  sprintf(rando, "%lu", 1+(unsigned long int) (1000000000.0 * rand()/(RAND_MAX+1.0)) );
  sprintf(windo, "%u", 1+(unsigned int) (4096.0 * rand()/(RAND_MAX+1.0)) );
  sprintf(srco, "%u", 1+(unsigned int) (6000.0 * rand()/(RAND_MAX+1.0)) );

  gtk_entry_set_text(GTK_ENTRY(src_te), srco);
  gtk_entry_set_text(GTK_ENTRY(dst_te), "23");
  gtk_entry_set_text(GTK_ENTRY(d_off_te), "5");
  gtk_entry_set_text(GTK_ENTRY(seq_te), rando);
  gtk_entry_set_text(GTK_ENTRY(ackseq_te), "0");
  gtk_entry_set_text(GTK_ENTRY(window_te), windo);
  gtk_entry_set_text(GTK_ENTRY(urgp_te), "0");


}

/* for agthering TCP packet header info */
struct packmack *tcp_gather(char *tcp_pack, struct in_addr sourcery, struct in_addr destined)
{
  struct tcphdr *tcp_magic = clalloc(S_TCP);
  struct nmrhdr *nmr_magic = clalloc(sizeof(struct nmrhdr));
  struct packmack *tcps = clalloc(sizeof(struct packmack));
  char data[65535 - S_TCPIP];
  int x, d_len = 0;

  memset(data, '\0', sizeof(data));
  /* check datalength and store data */
  if(sizeof(data) > gtk_text_get_length(GTK_TEXT(payload)))
  {
    for(x = 0; x < gtk_text_get_length(GTK_TEXT(payload)); x++)
    { data[x] = GTK_TEXT_INDEX(GTK_TEXT(payload), x); }
    d_len = strlen(data);
  }
  else
  { prterr("Data length to long for one packet!!"); }

  nmr_magic->saddr = sourcery;
  nmr_magic->daddr = destined;
  nmr_magic->none = 0;
  nmr_magic->protocol = 6;
  nmr_magic->length = htons(S_TCP + d_len);
   /* put the psuedo header in the pack which will be overwritten */
  memcpy(tcp_pack, nmr_magic, sizeof(struct nmrhdr));

  tcp_magic->th_sport= htons(atoi(gtk_entry_get_text(GTK_ENTRY(src_te))));
  tcp_magic->th_dport = htons(atoi(gtk_entry_get_text(GTK_ENTRY(dst_te))));
  tcp_magic->th_off = atoi(gtk_entry_get_text(GTK_ENTRY(d_off_te)));

  /*  tcp_magic->th_x2 = atoi(gtk_entry_get_text(GTK_ENTRY(rsv2_te))); */

  tcp_magic->th_seq = htonl(atoi(gtk_entry_get_text(GTK_ENTRY(seq_te))));
  tcp_magic->th_ack = htonl(atoi(gtk_entry_get_text(GTK_ENTRY(ackseq_te))));

  /* WFWGH - What flags we got here? */
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(urg_check)))
  { tcp_magic->th_flags += TH_URG; }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(syn_check)))
  { tcp_magic->th_flags += TH_SYN; }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ack_check)))
  { tcp_magic->th_flags += TH_ACK; }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(psh_check)))
  { tcp_magic->th_flags += TH_PUSH; }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rst_check)))
  { tcp_magic->th_flags += TH_RST; }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(fin_check)))
  { tcp_magic->th_flags += TH_FIN; }


  tcp_magic->th_win = htons(atoi(gtk_entry_get_text(GTK_ENTRY(window_te))));
  tcp_magic->th_urp = atoi(gtk_entry_get_text(GTK_ENTRY(urgp_te)));

   /* putting our tcp header in the packet */
  memcpy((tcp_pack + sizeof(struct nmrhdr)), tcp_magic, S_TCP);
  /* add data */
  memcpy(tcp_pack + sizeof(struct nmrhdr) + S_TCP, data, d_len);

  /* calculate checksum for the psuedo no miss routed packet header and tcp header */
  tcp_magic->th_sum = in_cksum((u_short *)tcp_pack, S_TCP + sizeof(struct nmrhdr) + d_len);

  free(nmr_magic);
  memcpy(tcp_pack + S_IP, tcp_magic, S_TCP);
  memcpy(tcp_pack + S_TCPIP, data, d_len);
  /* packet size and destination port */

  tcps->d_port = tcp_magic->th_dport;
  free(tcp_magic);
  tcps->packsz = S_TCPIP + d_len;

  return tcps;
}

/* clear all tcp widgets off the board ! */
void clear_tcp(void)
{
  gtk_widget_hide(src_lbl);
  gtk_widget_hide(src_te);
  gtk_widget_hide(dst_lbl);
  gtk_widget_hide(dst_te);
  gtk_widget_hide(d_off_lbl);
  gtk_widget_hide(d_off_te);
  gtk_widget_hide(seq_lbl);
  gtk_widget_hide(seq_te);
  gtk_widget_hide(ackseq_lbl);
  gtk_widget_hide(ackseq_te);
  gtk_widget_hide(window_lbl);
  gtk_widget_hide(window_te);
  gtk_widget_hide(urgp_lbl);
  gtk_widget_hide(urgp_te);
  gtk_widget_hide(syn_check);
  gtk_widget_hide(ack_check);
  gtk_widget_hide(psh_check);
  gtk_widget_hide(fin_check);
  gtk_widget_hide(urg_check);
  gtk_widget_hide(rst_check);

}

